using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Text;
using System.Drawing.Imaging;
using System.Windows.Forms;


namespace Np.FontTrans
{
	/// <summary>
	/// MainForm ̊Tv̐łB
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private NpFontTrans npft = new NpFontTrans();

		private System.Windows.Forms.PropertyGrid pg;
		private System.Windows.Forms.ComboBox cmbFontName;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtWidth;
		private System.Windows.Forms.TextBox txtHeight;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Panel pa;
		private System.Windows.Forms.VScrollBar vsb;
		private System.Windows.Forms.HScrollBar hsb;
		private System.Windows.Forms.PictureBox pb;
		private System.Windows.Forms.Button btncp;
		private System.Windows.Forms.Button btnisv;
		private System.Windows.Forms.SaveFileDialog sfd;
		private System.Windows.Forms.CheckBox chkAn;

		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
		}

		private void drawFontTrans()
		{
			pb.Width  = int.Parse(txtWidth.Text);
			if (pb.Width == 0) pb.Width = 800;

			pb.Height = int.Parse(txtHeight.Text);
			if (pb.Height == 0) pb.Height = 300;

			vsb.Maximum = pb.Height - pa.Height;
			vsb.Minimum = 0;
			hsb.Maximum = pb.Width - pa.Width;
			hsb.Minimum = 0;

			pb.Image = new Bitmap(pb.Width , pb.Height);
			Graphics g = Graphics.FromImage(pb.Image);
			g.PageUnit = GraphicsUnit.Pixel;
			g.FillRectangle(new SolidBrush(Color.White),0,0,pb.Width,pg.Height);
			if (chkAn.Checked) g.SmoothingMode = SmoothingMode.AntiAlias;
			npft.Draw(g);
			pg.SelectedObject = npft;
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.pg = new System.Windows.Forms.PropertyGrid();
			this.cmbFontName = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.txtWidth = new System.Windows.Forms.TextBox();
			this.txtHeight = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.pa = new System.Windows.Forms.Panel();
			this.pb = new System.Windows.Forms.PictureBox();
			this.vsb = new System.Windows.Forms.VScrollBar();
			this.hsb = new System.Windows.Forms.HScrollBar();
			this.btncp = new System.Windows.Forms.Button();
			this.btnisv = new System.Windows.Forms.Button();
			this.sfd = new System.Windows.Forms.SaveFileDialog();
			this.chkAn = new System.Windows.Forms.CheckBox();
			this.pa.SuspendLayout();
			this.SuspendLayout();
			// 
			// pg
			// 
			this.pg.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.pg.CommandsVisibleIfAvailable = true;
			this.pg.LargeButtons = false;
			this.pg.LineColor = System.Drawing.SystemColors.ScrollBar;
			this.pg.Location = new System.Drawing.Point(512, 40);
			this.pg.Name = "pg";
			this.pg.Size = new System.Drawing.Size(272, 496);
			this.pg.TabIndex = 3;
			this.pg.Text = "propertyGrid";
			this.pg.ViewBackColor = System.Drawing.SystemColors.Window;
			this.pg.ViewForeColor = System.Drawing.SystemColors.WindowText;
			this.pg.PropertyValueChanged += new System.Windows.Forms.PropertyValueChangedEventHandler(this.pg_PropertyValueChanged);
			// 
			// cmbFontName
			// 
			this.cmbFontName.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbFontName.Location = new System.Drawing.Point(229, 10);
			this.cmbFontName.Name = "cmbFontName";
			this.cmbFontName.Size = new System.Drawing.Size(192, 20);
			this.cmbFontName.TabIndex = 2;
			this.cmbFontName.SelectedIndexChanged += new System.EventHandler(this.cmbFontName_SelectedIndexChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(6, 14);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(24, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = ":";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(84, 14);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = ":";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// txtWidth
			// 
			this.txtWidth.Location = new System.Drawing.Point(38, 10);
			this.txtWidth.Name = "txtWidth";
			this.txtWidth.Size = new System.Drawing.Size(40, 19);
			this.txtWidth.TabIndex = 0;
			this.txtWidth.Text = "800";
			this.txtWidth.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtWidth.Leave += new System.EventHandler(this.txtWidth_Leave);
			// 
			// txtHeight
			// 
			this.txtHeight.Location = new System.Drawing.Point(124, 10);
			this.txtHeight.Name = "txtHeight";
			this.txtHeight.Size = new System.Drawing.Size(40, 19);
			this.txtHeight.TabIndex = 1;
			this.txtHeight.Text = "300";
			this.txtHeight.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtHeight.Leave += new System.EventHandler(this.txtHeight_Leave);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(175, 14);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(48, 16);
			this.label3.TabIndex = 7;
			this.label3.Text = "tHg:";
			this.label3.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// pa
			// 
			this.pa.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.pa.BackColor = System.Drawing.SystemColors.ControlDark;
			this.pa.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pa.Controls.AddRange(new System.Windows.Forms.Control[] {
																			 this.pb});
			this.pa.Location = new System.Drawing.Point(8, 38);
			this.pa.Name = "pa";
			this.pa.Size = new System.Drawing.Size(472, 514);
			this.pa.TabIndex = 8;
			// 
			// pb
			// 
			this.pb.BackColor = System.Drawing.Color.White;
			this.pb.Name = "pb";
			this.pb.Size = new System.Drawing.Size(400, 100);
			this.pb.TabIndex = 0;
			this.pb.TabStop = false;
			// 
			// vsb
			// 
			this.vsb.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.vsb.LargeChange = 100;
			this.vsb.Location = new System.Drawing.Point(480, 38);
			this.vsb.Name = "vsb";
			this.vsb.Size = new System.Drawing.Size(16, 506);
			this.vsb.TabIndex = 9;
			this.vsb.Scroll += new System.Windows.Forms.ScrollEventHandler(this.vsb_Scroll);
			// 
			// hsb
			// 
			this.hsb.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.hsb.LargeChange = 100;
			this.hsb.Location = new System.Drawing.Point(8, 552);
			this.hsb.Name = "hsb";
			this.hsb.Size = new System.Drawing.Size(468, 16);
			this.hsb.TabIndex = 10;
			this.hsb.Scroll += new System.Windows.Forms.ScrollEventHandler(this.hsb_Scroll);
			// 
			// btncp
			// 
			this.btncp.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.btncp.Location = new System.Drawing.Point(504, 544);
			this.btncp.Name = "btncp";
			this.btncp.Size = new System.Drawing.Size(136, 23);
			this.btncp.TabIndex = 11;
			this.btncp.Text = "Nbv{[hփRs[(&C)";
			this.btncp.Click += new System.EventHandler(this.btncp_Click);
			// 
			// btnisv
			// 
			this.btnisv.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.btnisv.Location = new System.Drawing.Point(648, 544);
			this.btnisv.Name = "btnisv";
			this.btnisv.Size = new System.Drawing.Size(136, 23);
			this.btnisv.TabIndex = 12;
			this.btnisv.Text = "摜t@Cɕۑ(&F)";
			this.btnisv.Click += new System.EventHandler(this.btnisv_Click);
			// 
			// sfd
			// 
			this.sfd.FileName = "NpFontTrans";
			this.sfd.Filter = "rbg}bv C[W` (*.bmp)|*.bmp|JPEGC[W` (*.jpg)|*.jpg|GIFC[W` (*.gif)|*.gif|TIFF" +
				"C[W` (*.tif)|*.tif|W3C PNGC[W` (*.png)|*.png";
			// 
			// chkAn
			// 
			this.chkAn.Checked = true;
			this.chkAn.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkAn.Location = new System.Drawing.Point(432, 8);
			this.chkAn.Name = "chkAn";
			this.chkAn.TabIndex = 3;
			this.chkAn.Text = ":A`GCAX";
			this.chkAn.CheckedChanged += new System.EventHandler(this.chkAn_CheckedChanged);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(792, 573);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.chkAn,
																		  this.btnisv,
																		  this.btncp,
																		  this.hsb,
																		  this.vsb,
																		  this.label3,
																		  this.txtHeight,
																		  this.txtWidth,
																		  this.label2,
																		  this.label1,
																		  this.cmbFontName,
																		  this.pg,
																		  this.pa});
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "NpFontTransApp";
			this.Resize += new System.EventHandler(this.MainForm_Resize);
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.pa.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{

			InstalledFontCollection ifc = new InstalledFontCollection();

			foreach (FontFamily fofa in ifc.Families )
			{
				cmbFontName.Items.Add(fofa.Name);
			}
			cmbFontName.SelectedItem = "lr ";

			npft.tHg = (string)cmbFontName.SelectedItem;
			drawFontTrans();
		}

		private void pg_PropertyValueChanged(object s, System.Windows.Forms.PropertyValueChangedEventArgs e)
		{
			drawFontTrans();
			cmbFontName.SelectedItem = npft.tHg;
		}

		private void cmbFontName_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			npft.tHg = (string)cmbFontName.SelectedItem;
			drawFontTrans();		
		}

		private void txtWidth_Leave(object sender, System.EventArgs e)
		{
			drawFontTrans();		
		}

		private void txtHeight_Leave(object sender, System.EventArgs e)
		{
			drawFontTrans();
		}

		private void chkAn_CheckedChanged(object sender, System.EventArgs e)
		{
			drawFontTrans();
		}

		private void vsb_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
			pb.Top = 0 - e.NewValue;
		}

		private void hsb_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
			pb.Left = 0 - e.NewValue;
		}

		private void btncp_Click(object sender, System.EventArgs e)
		{
			Clipboard.SetDataObject(pb.Image, true);
		}

		private void btnisv_Click(object sender, System.EventArgs e)
		{
			sfd.FileName = "NpFontTrans";
			if (sfd.ShowDialog() == DialogResult.OK)
			{
				try
				{
					string fn = sfd.FileName;
					switch(sfd.FilterIndex)
					{
						case 1:
							pb.Image.Save(sfd.FileName, ImageFormat.Bmp);
							break;
						case 2:
							pb.Image.Save(sfd.FileName, ImageFormat.Jpeg);
							break;
						case 3:
							pb.Image.Save(sfd.FileName, ImageFormat.Gif);
							break;
						case 4:
							pb.Image.Save(sfd.FileName, ImageFormat.Tiff);
							break;
						case 5:
							pb.Image.Save(sfd.FileName, ImageFormat.Png);
							break;
						default:
							pb.Image.Save(sfd.FileName, ImageFormat.Bmp);
							break;
					}
				}
				catch (BadImageFormatException ex)
				{
					MessageBox.Show(this, ex.Message, this.Text);
					return;
				}
			}
		}

		private void MainForm_Resize(object sender, System.EventArgs e)
		{
			vsb.Maximum = pb.Height - pa.Height;
			vsb.Minimum = 0;
			hsb.Maximum = pb.Width - pa.Width;
			hsb.Minimum = 0;
		}

	}
}
